// blocks.inc
// contains wooden blocks with letters of the alphabet on them.
// Anyway, the bottom of the blocks is on the y=0 plane, and the
// blocks are 3x3x3 cubes.

#macro AlphaBlock(strL,colB)
#local rR=.15;
#local xW=1.5;
#local yH=3;
#local yB=0;
#local letT=text { ttf "timrom.ttf",strL,.1,0 }

#ifndef(BlockRand) #local BlockRand=seed(0); #end
#local transW=transform {
  rotate <rand(BlockRand),rand(BlockRand),rand(BlockRand)>*10-5
  translate <rand(BlockRand),rand(BlockRand),rand(BlockRand)>*10-5
}

union {
  CutCylinder(<xW-rR,yH-rR,-1.5>,<xW-rR,yH-rR,1.5>,rR,0, x+y)
  CutCylinder(<xW-rR,yB+rR,-1.5>,<xW-rR,yB+rR,1.5>,rR,0, x-y)
  CutCylinder(<rR-xW,yH-rR,-1.5>,<rR-xW,yH-rR,1.5>,rR,0,-x+y)
  CutCylinder(<rR-xW,yB+rR,-1.5>,<rR-xW,yB+rR,1.5>,rR,0,-x-y)
  box { <rR-xW,yB,-1.5>,<xW-rR,yB+rR,1.5> }
  box { <rR-xW,yH-rR,-1.5>,<xW-rR,yH,1.5> }
  box { <-xW,yB+rR,-1.5>,<rR-xW,yH-rR,1.5> }
  box { <xW-rR,yB+rR,-1.5>,< xW,yH-rR,1.5> }

  box { <rR-xW,rR,-1.4>,<xW-rR,yH-rR, 1.4> }
  object { letT translate (min_extent(letT)-max_extent(letT))*<.5,.5,0> scale 3 translate -z*1.5+y*1.5 }
  object { letT translate (min_extent(letT)-max_extent(letT))*<.5,.5,0> scale <-3,3,-3> translate z*1.5+y*1.5 }
  pigment {
    gradient z translate -.5 scale 3
    pigment_map {
      [.02 colB]
      [.02 wood
        scale <.1,.1,1> transform transW
        turbulence .05
        color_map { [.5, rgb <1,.7,.4> ] [1, rgb <.7,.4,.1> ] }
      ]
      [.98 wood
        scale <.1,.1,1> transform transW
        turbulence .05
        color_map { [.5, rgb <1,.7,.4> ] [1, rgb <.7,.4,.1> ] }
      ]
      [.98 colB ]
    }
  }
}
#end
